---
---
<!-- HTML header for doxygen 1.8.10-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>TGUI: include/TGUI/Widget.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
<!-- BEGIN CUSTOM 1 -->
<!-- --{{""}}>
{% include head.ext %}
<style>
  div {
    margin-bottom: 0
  }
  #contents {
    padding-left: 0;
    padding-right: 0;
    margin-left: 0;
    margin-right: 0;
    max-width: 1060px;
  }
  address.footer {
    padding-bottom: 1.4em;
  }
</style>
<script type="text/javascript">
function getXPos(item) {
  var x = 0;
  if (item.offsetWidth) {
    while (item && item != document.body && item.id != 'body') {
      x   += item.offsetLeft;
      item = item.offsetParent;
    }
  }
  return x;
}
</script>
<{{""}}!-- -->
<!-- END CUSTOM 1 -->
</head>
<body>
<!-- BEGIN CUSTOM 2 -->
<!-- --{{""}}>
<div id="body" class="NoMargin">
{% include navigation.ext %}
<div id="contents" class="NoMargin">
<{{""}}!-- {% raw %} -->
<!-- END CUSTOM 2 -->
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">TGUI
   &#160;<span id="projectnumber">v0.7-dev</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_380f920385a16f176be7632160138052.html">TGUI</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Widget.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment">// TGUI - Texus&#39;s Graphical User Interface</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Copyright (C) 2012-2017 Bruno Van de Velde (vdv_b@tgui.eu)</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">// This software is provided &#39;as-is&#39;, without any express or implied warranty.</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">// In no event will the authors be held liable for any damages arising from the use of this software.</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">// Permission is granted to anyone to use this software for any purpose,</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">// including commercial applications, and to alter it and redistribute it freely,</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">// subject to the following restrictions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">// 1. The origin of this software must not be misrepresented;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">//    you must not claim that you wrote the original software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment">//    If you use this software in a product, an acknowledgment</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//    in the product documentation would be appreciated but is not required.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">// 2. Altered source versions must be plainly marked as such,</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">//    and must not be misrepresented as being the original software.</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment">// 3. This notice may not be removed or altered from any source distribution.</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment">//</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"></span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#ifndef TGUI_WIDGETS_HPP</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#define TGUI_WIDGETS_HPP</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &lt;TGUI/Global.hpp&gt;</span></div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="preprocessor">#include &lt;TGUI/Signal.hpp&gt;</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#include &lt;TGUI/Transformable.hpp&gt;</span></div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="preprocessor">#include &lt;TGUI/Texture.hpp&gt;</span></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#include &lt;TGUI/Color.hpp&gt;</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#include &lt;TGUI/Font.hpp&gt;</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;<span class="preprocessor">#include &lt;TGUI/Loading/Deserializer.hpp&gt;</span></div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacetgui.html">tgui</a></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;{</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    <span class="keyword">class </span>BaseTheme;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">class </span>Container;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">class </span>WidgetRenderer;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">enum class</span> <a class="code" href="namespacetgui.html#ae5f90d6756ae21ba5dd08f84138437da">ShowAnimationType</a>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">namespace </span>priv</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    {</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keyword">class </span>Animation;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    }</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00071"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html">   71</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1Widget.html">Widget</a> : <span class="keyword">public</span> sf::Drawable, <span class="keyword">public</span> <a class="code" href="classtgui_1_1Transformable.html">Transformable</a>, <span class="keyword">public</span> <a class="code" href="classtgui_1_1SignalWidgetBase.html">SignalWidgetBase</a>, <span class="keyword">public</span> std::enable_shared_from_this&lt;Widget&gt;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    {</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">   75</a></span>&#160;        <span class="keyword">typedef</span> std::shared_ptr&lt;Widget&gt; <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Ptr</a>; </div><div class="line"><a name="l00076"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#aeaa9564fad89042e53af59e7a0063b1f">   76</a></span>&#160;        <span class="keyword">typedef</span> std::shared_ptr&lt;const Widget&gt; <a class="code" href="classtgui_1_1Widget.html#aeaa9564fad89042e53af59e7a0063b1f">ConstPtr</a>; </div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <a class="code" href="classtgui_1_1Widget.html">Widget</a>();</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;        <a class="code" href="classtgui_1_1Widget.html">Widget</a>(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Widget.html">Widget</a>&amp; copy);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        ~<a class="code" href="classtgui_1_1Widget.html">Widget</a>();</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;        <a class="code" href="classtgui_1_1Widget.html">Widget</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classtgui_1_1Widget.html">Widget</a>&amp; right);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#a6d296b4082518366caeb0d3101d0320f">  117</a></span>&#160;        std::shared_ptr&lt;WidgetRenderer&gt; <a class="code" href="classtgui_1_1Widget.html#a6d296b4082518366caeb0d3101d0320f">getRenderer</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            <span class="keywordflow">return</span> m_renderer;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;        }</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setPosition(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a>&amp; position) <span class="keyword">override</span>;</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        <span class="keyword">using</span> <a class="code" href="classtgui_1_1Transformable.html#aef14a1428f63eeb8bd820a1b4821a3d0">Transformable::setPosition</a>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setSize(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Layout2d.html">Layout2d</a>&amp; size) <span class="keyword">override</span>;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keyword">using</span> <a class="code" href="classtgui_1_1Transformable.html#a66fe5d2a7b1477cab073984a9a3e13bc">Transformable::setSize</a>;</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="keyword">virtual</span> sf::Vector2f getAbsolutePosition() <span class="keyword">const</span>;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> show();</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> showWithEffect(<a class="code" href="namespacetgui.html#ae5f90d6756ae21ba5dd08f84138437da">ShowAnimationType</a> type, sf::Time duration);</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> hide();</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> hideWithEffect(<a class="code" href="namespacetgui.html#ae5f90d6756ae21ba5dd08f84138437da">ShowAnimationType</a> type, sf::Time duration);</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#ac30d0e386c262c5e830fdcc994584993">  244</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classtgui_1_1Widget.html#ac30d0e386c262c5e830fdcc994584993">isVisible</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;            <span class="keywordflow">return</span> m_visible;</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        }</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> enable();</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> disable(<span class="keywordtype">bool</span> blockMouseEvents = <span class="keyword">true</span>);</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;</div><div class="line"><a name="l00281"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#af6770fc71c644b645bf28f31c4efd2d1">  281</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classtgui_1_1Widget.html#af6770fc71c644b645bf28f31c4efd2d1">isEnabled</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;            <span class="keywordflow">return</span> m_enabled;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        }</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> focus();</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> unfocus();</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;</div><div class="line"><a name="l00315"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#af9a2f1246195375dea450655b23cdf6d">  315</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="classtgui_1_1Widget.html#af9a2f1246195375dea450655b23cdf6d">isFocused</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;            <span class="keywordflow">return</span> m_focused;</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        }</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;</div><div class="line"><a name="l00327"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#a52f98861e54bde43ccab0abe5733bfff">  327</a></span>&#160;        <span class="keyword">const</span> std::string&amp; <a class="code" href="classtgui_1_1Widget.html#a52f98861e54bde43ccab0abe5733bfff">getWidgetType</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;            <span class="keywordflow">return</span> m_callback.widgetType;</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        }</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#a0cf4e57ff28230753afe8197e8945a3a">  339</a></span>&#160;        <a class="code" href="classtgui_1_1Container.html">Container</a>* <a class="code" href="classtgui_1_1Widget.html#a0cf4e57ff28230753afe8197e8945a3a">getParent</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            <span class="keywordflow">return</span> m_parent;</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;        }</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setOpacity(<span class="keywordtype">float</span> opacity);</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;</div><div class="line"><a name="l00360"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#a7ab7b54eb87d1c7b28ad36fa5a8281ec">  360</a></span>&#160;        <span class="keywordtype">float</span> <a class="code" href="classtgui_1_1Widget.html#a7ab7b54eb87d1c7b28ad36fa5a8281ec">getOpacity</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;            <span class="keywordflow">return</span> m_opacity;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;        }</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> moveToFront();</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> moveToBack();</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        <span class="keywordtype">void</span> setToolTip(<a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> toolTip);</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;</div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> getToolTip();</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFont(<span class="keyword">const</span> <a class="code" href="classtgui_1_1Font.html">Font</a>&amp; font);</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;        std::shared_ptr&lt;sf::Font&gt; getFont() <span class="keyword">const</span>;</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;        <span class="keywordtype">void</span> detachTheme();</div><div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;</div><div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;</div><div class="line"><a name="l00435"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#ab5bb8483e23d877c386d632ca7ca2879">  435</a></span>&#160;        std::shared_ptr&lt;BaseTheme&gt; <a class="code" href="classtgui_1_1Widget.html#ab5bb8483e23d877c386d632ca7ca2879">getTheme</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;            <span class="keywordflow">return</span> m_theme;</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;        }</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;</div><div class="line"><a name="l00447"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#aa32ce148343fd2a0f59d6dbcc3028883">  447</a></span>&#160;        std::string <a class="code" href="classtgui_1_1Widget.html#aa32ce148343fd2a0f59d6dbcc3028883">getPrimaryLoadingParameter</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;            <span class="keywordflow">return</span> m_primaryLoadingParameter;</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;        }</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;</div><div class="line"><a name="l00459"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#a97e7325f223c7c49105b3b859542b652">  459</a></span>&#160;        std::string <a class="code" href="classtgui_1_1Widget.html#a97e7325f223c7c49105b3b859542b652">getSecondaryLoadingParameter</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;            <span class="keywordflow">return</span> m_secondaryLoadingParameter;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;        }</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;</div><div class="line"><a name="l00473"></a><span class="lineno"><a class="line" href="classtgui_1_1Widget.html#a569db174bec35957e0150f14b25a6423">  473</a></span>&#160;        <span class="keyword">virtual</span> sf::Vector2f <a class="code" href="classtgui_1_1Widget.html#a569db174bec35957e0150f14b25a6423">getWidgetOffset</a>()<span class="keyword"> const</span></div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;<span class="keyword">        </span>{</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;            <span class="keywordflow">return</span> sf::Vector2f{0, 0};</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;        }</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setParent(<a class="code" href="classtgui_1_1Container.html">Container</a>* parent);</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;</div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> update(sf::Time elapsedTime);</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">bool</span> mouseOnWidget(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y) <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> leftMousePressed(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y);</div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> leftMouseReleased(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y);</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;</div><div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseMoved(<span class="keywordtype">float</span> x, <span class="keywordtype">float</span> y);</div><div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;</div><div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> keyPressed(<span class="keyword">const</span> sf::Event::KeyEvent&amp; event);</div><div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;</div><div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> textEntered(sf::Uint32 key);</div><div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;</div><div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseWheelMoved(<span class="keywordtype">int</span> delta, <span class="keywordtype">int</span> x, <span class="keywordtype">int</span> y);</div><div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160;</div><div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> widgetFocused();</div><div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;</div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> widgetUnfocused();</div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseNoLongerOnWidget();</div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;</div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseNoLongerDown();</div><div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;</div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;        <span class="comment">// Show the tool tip when the widget is located below the mouse.</span></div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;        <span class="comment">// Returns its tool tip or the tool tip from a child widget if the mouse is on top of the widget.</span></div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;        <span class="comment">// A nullptr is returned when the mouse is not on top of the widget or when the tool tip is empty.</span></div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> askToolTip(sf::Vector2f mousePos);</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;</div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> clone() <span class="keyword">const</span> = 0;</div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;</div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;</div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;        <span class="keywordtype">void</span> attachTheme(std::shared_ptr&lt;BaseTheme&gt; theme);</div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;</div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> reload(<span class="keyword">const</span> std::string&amp; primary = <span class="stringliteral">&quot;&quot;</span>, <span class="keyword">const</span> std::string&amp; secondary = <span class="stringliteral">&quot;&quot;</span>, <span class="keywordtype">bool</span> force = <span class="keyword">false</span>);</div><div class="line"><a name="l00598"></a><span class="lineno">  598</span>&#160;</div><div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;</div><div class="line"><a name="l00601"></a><span class="lineno">  601</span>&#160;        <span class="comment">// This function is called when the mouse enters the widget. If requested, a callback will be send.</span></div><div class="line"><a name="l00603"></a><span class="lineno">  603</span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseEnteredWidget();</div><div class="line"><a name="l00604"></a><span class="lineno">  604</span>&#160;</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;</div><div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;        <span class="comment">// This function is called when the mouse leaves the widget. If requested, a callback will be send.</span></div><div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> <span class="keywordtype">void</span> mouseLeftWidget();</div><div class="line"><a name="l00610"></a><span class="lineno">  610</span>&#160;</div><div class="line"><a name="l00611"></a><span class="lineno">  611</span>&#160;</div><div class="line"><a name="l00613"></a><span class="lineno">  613</span>&#160;        <span class="comment">// Check if the widget blocks mouse events when disabled</span></div><div class="line"><a name="l00615"></a><span class="lineno">  615</span>&#160;<span class="comment"></span>        <span class="keywordtype">bool</span> isDisabledBlockingMouseEvents() <span class="keyword">const</span>;</div><div class="line"><a name="l00616"></a><span class="lineno">  616</span>&#160;</div><div class="line"><a name="l00617"></a><span class="lineno">  617</span>&#160;</div><div class="line"><a name="l00619"></a><span class="lineno">  619</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00620"></a><span class="lineno">  620</span>&#160;</div><div class="line"><a name="l00621"></a><span class="lineno">  621</span>&#160;        <span class="comment">// Block mouse events when the widget is disabled or let them pass to the widget behind it?</span></div><div class="line"><a name="l00622"></a><span class="lineno">  622</span>&#160;        <span class="keywordtype">bool</span> m_disabledBlockingMouseEvents = <span class="keyword">true</span>;</div><div class="line"><a name="l00623"></a><span class="lineno">  623</span>&#160;</div><div class="line"><a name="l00624"></a><span class="lineno">  624</span>&#160;        <span class="comment">// When a widget is disabled, it will no longer receive events</span></div><div class="line"><a name="l00625"></a><span class="lineno">  625</span>&#160;        <span class="keywordtype">bool</span> m_enabled = <span class="keyword">true</span>;</div><div class="line"><a name="l00626"></a><span class="lineno">  626</span>&#160;</div><div class="line"><a name="l00627"></a><span class="lineno">  627</span>&#160;        <span class="comment">// Is the widget visible? When it is invisible it will not receive events and it won&#39;t be drawn.</span></div><div class="line"><a name="l00628"></a><span class="lineno">  628</span>&#160;        <span class="keywordtype">bool</span> m_visible = <span class="keyword">true</span>;</div><div class="line"><a name="l00629"></a><span class="lineno">  629</span>&#160;</div><div class="line"><a name="l00630"></a><span class="lineno">  630</span>&#160;        <span class="comment">// This will point to our parent widget. If there is no parent then this will be nullptr.</span></div><div class="line"><a name="l00631"></a><span class="lineno">  631</span>&#160;        <a class="code" href="classtgui_1_1Container.html">Container</a>* m_parent = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00632"></a><span class="lineno">  632</span>&#160;</div><div class="line"><a name="l00633"></a><span class="lineno">  633</span>&#160;        <span class="comment">// How transparent is the widget</span></div><div class="line"><a name="l00634"></a><span class="lineno">  634</span>&#160;        <span class="keywordtype">float</span> m_opacity = 1;</div><div class="line"><a name="l00635"></a><span class="lineno">  635</span>&#160;</div><div class="line"><a name="l00636"></a><span class="lineno">  636</span>&#160;        <span class="comment">// Is the mouse on top of the widget? Did the mouse go down on the widget?</span></div><div class="line"><a name="l00637"></a><span class="lineno">  637</span>&#160;        <span class="keywordtype">bool</span> m_mouseHover = <span class="keyword">false</span>;</div><div class="line"><a name="l00638"></a><span class="lineno">  638</span>&#160;        <span class="keywordtype">bool</span> m_mouseDown = <span class="keyword">false</span>;</div><div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;</div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;        <span class="comment">// Are you focused on the widget?</span></div><div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;        <span class="keywordtype">bool</span> m_focused = <span class="keyword">false</span>;</div><div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;</div><div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;        <span class="comment">// Can the widget be focused?</span></div><div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;        <span class="keywordtype">bool</span> m_allowFocus = <span class="keyword">false</span>;</div><div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;</div><div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;        <span class="comment">// Keep track of the elapsed time.</span></div><div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;        sf::Time m_animationTimeElapsed;</div><div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;</div><div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;        <span class="comment">// This is set to true for widgets that have something to be dragged around (e.g. sliders and scrollbars)</span></div><div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;        <span class="keywordtype">bool</span> m_draggableWidget = <span class="keyword">false</span>;</div><div class="line"><a name="l00651"></a><span class="lineno">  651</span>&#160;</div><div class="line"><a name="l00652"></a><span class="lineno">  652</span>&#160;        <span class="comment">// This is set to true for widgets that store other widgets inside them</span></div><div class="line"><a name="l00653"></a><span class="lineno">  653</span>&#160;        <span class="keywordtype">bool</span> m_containerWidget = <span class="keyword">false</span>;</div><div class="line"><a name="l00654"></a><span class="lineno">  654</span>&#160;</div><div class="line"><a name="l00655"></a><span class="lineno">  655</span>&#160;        <span class="comment">// The tool tip connected to the widget</span></div><div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;        <a class="code" href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">Widget::Ptr</a> m_toolTip = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00657"></a><span class="lineno">  657</span>&#160;</div><div class="line"><a name="l00658"></a><span class="lineno">  658</span>&#160;        <span class="comment">// The font that the widget can use</span></div><div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;        std::shared_ptr&lt;sf::Font&gt; m_font = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00660"></a><span class="lineno">  660</span>&#160;</div><div class="line"><a name="l00661"></a><span class="lineno">  661</span>&#160;        <span class="comment">// Renderer of the widget</span></div><div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;        std::shared_ptr&lt;WidgetRenderer&gt; m_renderer = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160;</div><div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;        <span class="comment">// Theme object that loaded this widget (if any)</span></div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;        std::shared_ptr&lt;BaseTheme&gt; m_theme = <span class="keyword">nullptr</span>;</div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;        std::string m_primaryLoadingParameter;</div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;        std::string m_secondaryLoadingParameter;</div><div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;</div><div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;        <span class="comment">// Show animations</span></div><div class="line"><a name="l00670"></a><span class="lineno">  670</span>&#160;        std::vector&lt;std::shared_ptr&lt;priv::Animation&gt;&gt; m_showAnimations;</div><div class="line"><a name="l00671"></a><span class="lineno">  671</span>&#160;</div><div class="line"><a name="l00673"></a><span class="lineno">  673</span>&#160;</div><div class="line"><a name="l00674"></a><span class="lineno">  674</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classtgui_1_1Container.html">Container</a>;</div><div class="line"><a name="l00675"></a><span class="lineno">  675</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classtgui_1_1BaseTheme.html">BaseTheme</a>;</div><div class="line"><a name="l00676"></a><span class="lineno">  676</span>&#160;    };</div><div class="line"><a name="l00677"></a><span class="lineno">  677</span>&#160;</div><div class="line"><a name="l00678"></a><span class="lineno">  678</span>&#160;</div><div class="line"><a name="l00682"></a><span class="lineno"><a class="line" href="classtgui_1_1WidgetRenderer.html">  682</a></span>&#160;    <span class="keyword">class </span>TGUI_API <a class="code" href="classtgui_1_1WidgetRenderer.html">WidgetRenderer</a></div><div class="line"><a name="l00683"></a><span class="lineno">  683</span>&#160;    {</div><div class="line"><a name="l00684"></a><span class="lineno">  684</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00685"></a><span class="lineno">  685</span>&#160;</div><div class="line"><a name="l00690"></a><span class="lineno"><a class="line" href="classtgui_1_1WidgetRenderer.html#aa9ffbba1a051a6eaf0e1d069d78377ca">  690</a></span>&#160;        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1WidgetRenderer.html#aa9ffbba1a051a6eaf0e1d069d78377ca">~WidgetRenderer</a>() {};</div><div class="line"><a name="l00691"></a><span class="lineno">  691</span>&#160;</div><div class="line"><a name="l00692"></a><span class="lineno">  692</span>&#160;</div><div class="line"><a name="l00702"></a><span class="lineno">  702</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setProperty(std::string property, <span class="keyword">const</span> std::string&amp; value);</div><div class="line"><a name="l00703"></a><span class="lineno">  703</span>&#160;</div><div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;</div><div class="line"><a name="l00715"></a><span class="lineno">  715</span>&#160;        <span class="keyword">virtual</span> <span class="keywordtype">void</span> setProperty(std::string property, <a class="code" href="classtgui_1_1ObjectConverter.html">ObjectConverter</a>&amp;&amp; value);</div><div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160;</div><div class="line"><a name="l00717"></a><span class="lineno">  717</span>&#160;</div><div class="line"><a name="l00727"></a><span class="lineno">  727</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="classtgui_1_1ObjectConverter.html">ObjectConverter</a> getProperty(std::string property) <span class="keyword">const</span>;</div><div class="line"><a name="l00728"></a><span class="lineno">  728</span>&#160;</div><div class="line"><a name="l00729"></a><span class="lineno">  729</span>&#160;</div><div class="line"><a name="l00736"></a><span class="lineno">  736</span>&#160;        <span class="keyword">virtual</span> std::map&lt;std::string, ObjectConverter&gt; getPropertyValuePairs() <span class="keyword">const</span>;</div><div class="line"><a name="l00737"></a><span class="lineno">  737</span>&#160;</div><div class="line"><a name="l00738"></a><span class="lineno">  738</span>&#160;</div><div class="line"><a name="l00740"></a><span class="lineno">  740</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00741"></a><span class="lineno">  741</span>&#160;</div><div class="line"><a name="l00743"></a><span class="lineno">  743</span>&#160;        <span class="comment">// Makes a copy of the renderer</span></div><div class="line"><a name="l00745"></a><span class="lineno">  745</span>&#160;<span class="comment"></span>        <span class="keyword">virtual</span> std::shared_ptr&lt;WidgetRenderer&gt; clone(<a class="code" href="classtgui_1_1Widget.html">Widget</a>* widget) = 0;</div><div class="line"><a name="l00746"></a><span class="lineno">  746</span>&#160;</div><div class="line"><a name="l00747"></a><span class="lineno">  747</span>&#160;</div><div class="line"><a name="l00749"></a><span class="lineno">  749</span>&#160;</div><div class="line"><a name="l00750"></a><span class="lineno">  750</span>&#160;        <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classtgui_1_1Widget.html">Widget</a>;</div><div class="line"><a name="l00751"></a><span class="lineno">  751</span>&#160;    };</div><div class="line"><a name="l00752"></a><span class="lineno">  752</span>&#160;</div><div class="line"><a name="l00753"></a><span class="lineno">  753</span>&#160;</div><div class="line"><a name="l00755"></a><span class="lineno">  755</span>&#160;}</div><div class="line"><a name="l00756"></a><span class="lineno">  756</span>&#160;</div><div class="line"><a name="l00758"></a><span class="lineno">  758</span>&#160;</div><div class="line"><a name="l00759"></a><span class="lineno">  759</span>&#160;<span class="preprocessor">#endif // TGUI_WIDGETS_HPP</span></div><div class="ttc" id="namespacetgui_html"><div class="ttname"><a href="namespacetgui.html">tgui</a></div><div class="ttdoc">Namespace that contains all TGUI functions and classes. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:33</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_af9a2f1246195375dea450655b23cdf6d"><div class="ttname"><a href="classtgui_1_1Widget.html#af9a2f1246195375dea450655b23cdf6d">tgui::Widget::isFocused</a></div><div class="ttdeci">bool isFocused() const </div><div class="ttdoc">Returns true when the widget is focused and false otherwise. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:315</div></div>
<div class="ttc" id="classtgui_1_1Transformable_html"><div class="ttname"><a href="classtgui_1_1Transformable.html">tgui::Transformable</a></div><div class="ttdef"><b>Definition:</b> Transformable.hpp:36</div></div>
<div class="ttc" id="classtgui_1_1Font_html"><div class="ttname"><a href="classtgui_1_1Font.html">tgui::Font</a></div><div class="ttdef"><b>Definition:</b> Font.hpp:37</div></div>
<div class="ttc" id="classtgui_1_1Layout2d_html"><div class="ttname"><a href="classtgui_1_1Layout2d.html">tgui::Layout2d</a></div><div class="ttdoc">Class to store the position or size of a widget. </div><div class="ttdef"><b>Definition:</b> Layout.hpp:254</div></div>
<div class="ttc" id="classtgui_1_1Widget_html"><div class="ttname"><a href="classtgui_1_1Widget.html">tgui::Widget</a></div><div class="ttdoc">The parent class for every widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:71</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_aeaa9564fad89042e53af59e7a0063b1f"><div class="ttname"><a href="classtgui_1_1Widget.html#aeaa9564fad89042e53af59e7a0063b1f">tgui::Widget::ConstPtr</a></div><div class="ttdeci">std::shared_ptr&lt; const Widget &gt; ConstPtr</div><div class="ttdoc">Shared constant widget pointer. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:76</div></div>
<div class="ttc" id="classtgui_1_1SignalWidgetBase_html"><div class="ttname"><a href="classtgui_1_1SignalWidgetBase.html">tgui::SignalWidgetBase</a></div><div class="ttdoc">Base class for widgets to enable signal handling. </div><div class="ttdef"><b>Definition:</b> Signal.hpp:312</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a7ab7b54eb87d1c7b28ad36fa5a8281ec"><div class="ttname"><a href="classtgui_1_1Widget.html#a7ab7b54eb87d1c7b28ad36fa5a8281ec">tgui::Widget::getOpacity</a></div><div class="ttdeci">float getOpacity() const </div><div class="ttdoc">Returns the opacity of the widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:360</div></div>
<div class="ttc" id="namespacetgui_html_ae5f90d6756ae21ba5dd08f84138437da"><div class="ttname"><a href="namespacetgui.html#ae5f90d6756ae21ba5dd08f84138437da">tgui::ShowAnimationType</a></div><div class="ttdeci">ShowAnimationType</div><div class="ttdoc">Type of animation to show/hide widget. </div><div class="ttdef"><b>Definition:</b> Animation.hpp:38</div></div>
<div class="ttc" id="classtgui_1_1Transformable_html_a66fe5d2a7b1477cab073984a9a3e13bc"><div class="ttname"><a href="classtgui_1_1Transformable.html#a66fe5d2a7b1477cab073984a9a3e13bc">tgui::Transformable::setSize</a></div><div class="ttdeci">virtual void setSize(const Layout2d &amp;size)</div><div class="ttdoc">Changes the size of the widget. </div></div>
<div class="ttc" id="classtgui_1_1Transformable_html_aef14a1428f63eeb8bd820a1b4821a3d0"><div class="ttname"><a href="classtgui_1_1Transformable.html#aef14a1428f63eeb8bd820a1b4821a3d0">tgui::Transformable::setPosition</a></div><div class="ttdeci">virtual void setPosition(const Layout2d &amp;position)</div><div class="ttdoc">set the position of the widget </div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a0cf4e57ff28230753afe8197e8945a3a"><div class="ttname"><a href="classtgui_1_1Widget.html#a0cf4e57ff28230753afe8197e8945a3a">tgui::Widget::getParent</a></div><div class="ttdeci">Container * getParent() const </div><div class="ttdoc">Returns a pointer to the parent widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:339</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_ab5bb8483e23d877c386d632ca7ca2879"><div class="ttname"><a href="classtgui_1_1Widget.html#ab5bb8483e23d877c386d632ca7ca2879">tgui::Widget::getTheme</a></div><div class="ttdeci">std::shared_ptr&lt; BaseTheme &gt; getTheme() const </div><div class="ttdoc">Returns the theme to which the widget is currently connected. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:435</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_aa32ce148343fd2a0f59d6dbcc3028883"><div class="ttname"><a href="classtgui_1_1Widget.html#aa32ce148343fd2a0f59d6dbcc3028883">tgui::Widget::getPrimaryLoadingParameter</a></div><div class="ttdeci">std::string getPrimaryLoadingParameter() const </div><div class="ttdoc">Returns the primary parameter that was passed to the loader to load this widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:447</div></div>
<div class="ttc" id="classtgui_1_1ObjectConverter_html"><div class="ttname"><a href="classtgui_1_1ObjectConverter.html">tgui::ObjectConverter</a></div><div class="ttdoc">Implicit converter for settable properties. </div><div class="ttdef"><b>Definition:</b> ObjectConverter.hpp:42</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a388912f13898735531886bc676b14f81"><div class="ttname"><a href="classtgui_1_1Widget.html#a388912f13898735531886bc676b14f81">tgui::Widget::Ptr</a></div><div class="ttdeci">std::shared_ptr&lt; Widget &gt; Ptr</div><div class="ttdoc">Shared widget pointer. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:75</div></div>
<div class="ttc" id="classtgui_1_1Container_html"><div class="ttname"><a href="classtgui_1_1Container.html">tgui::Container</a></div><div class="ttdoc">Container widget. </div><div class="ttdef"><b>Definition:</b> Container.hpp:47</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_af6770fc71c644b645bf28f31c4efd2d1"><div class="ttname"><a href="classtgui_1_1Widget.html#af6770fc71c644b645bf28f31c4efd2d1">tgui::Widget::isEnabled</a></div><div class="ttdeci">bool isEnabled() const </div><div class="ttdoc">Returns true when the widget is enabled. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:281</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a52f98861e54bde43ccab0abe5733bfff"><div class="ttname"><a href="classtgui_1_1Widget.html#a52f98861e54bde43ccab0abe5733bfff">tgui::Widget::getWidgetType</a></div><div class="ttdeci">const std::string &amp; getWidgetType() const </div><div class="ttdoc">Returns the type of the widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:327</div></div>
<div class="ttc" id="classtgui_1_1WidgetRenderer_html_aa9ffbba1a051a6eaf0e1d069d78377ca"><div class="ttname"><a href="classtgui_1_1WidgetRenderer.html#aa9ffbba1a051a6eaf0e1d069d78377ca">tgui::WidgetRenderer::~WidgetRenderer</a></div><div class="ttdeci">virtual ~WidgetRenderer()</div><div class="ttdoc">Virtual destructor. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:690</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_ac30d0e386c262c5e830fdcc994584993"><div class="ttname"><a href="classtgui_1_1Widget.html#ac30d0e386c262c5e830fdcc994584993">tgui::Widget::isVisible</a></div><div class="ttdeci">bool isVisible() const </div><div class="ttdoc">Returns true when the widget is visible. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:244</div></div>
<div class="ttc" id="classtgui_1_1BaseTheme_html"><div class="ttname"><a href="classtgui_1_1BaseTheme.html">tgui::BaseTheme</a></div><div class="ttdoc">Base class for the Theme classes. </div><div class="ttdef"><b>Definition:</b> Theme.hpp:42</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a97e7325f223c7c49105b3b859542b652"><div class="ttname"><a href="classtgui_1_1Widget.html#a97e7325f223c7c49105b3b859542b652">tgui::Widget::getSecondaryLoadingParameter</a></div><div class="ttdeci">std::string getSecondaryLoadingParameter() const </div><div class="ttdoc">Returns the secondary parameter that was passed to the loader to load this widget. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:459</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a569db174bec35957e0150f14b25a6423"><div class="ttname"><a href="classtgui_1_1Widget.html#a569db174bec35957e0150f14b25a6423">tgui::Widget::getWidgetOffset</a></div><div class="ttdeci">virtual sf::Vector2f getWidgetOffset() const </div><div class="ttdoc">Returns the distance between the position where the widget is drawn and where the widget is placed...</div><div class="ttdef"><b>Definition:</b> Widget.hpp:473</div></div>
<div class="ttc" id="classtgui_1_1Widget_html_a6d296b4082518366caeb0d3101d0320f"><div class="ttname"><a href="classtgui_1_1Widget.html#a6d296b4082518366caeb0d3101d0320f">tgui::Widget::getRenderer</a></div><div class="ttdeci">std::shared_ptr&lt; WidgetRenderer &gt; getRenderer() const </div><div class="ttdoc">Returns the renderer, which gives access to functions that determine how the widget is displayed...</div><div class="ttdef"><b>Definition:</b> Widget.hpp:117</div></div>
<div class="ttc" id="classtgui_1_1WidgetRenderer_html"><div class="ttname"><a href="classtgui_1_1WidgetRenderer.html">tgui::WidgetRenderer</a></div><div class="ttdoc">Base class for all renderer classes. </div><div class="ttdef"><b>Definition:</b> Widget.hpp:682</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- HTML footer for doxygen 1.8.10-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Nov 25 2017 17:32:41 for TGUI by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.11
</small></address>
<!-- BEGIN CUSTOM 3 -->
<!-- {% endraw %} -{{""}}-{{""}}>
</div>
{% include page_footer.ext %}
</div>
{% include footer.ext %}
<{{""}}!{{""}}-{{""}}- -->
<!-- END CUSTOM 3 -->
</body>
</html>
